/*******************************************************************************
*
 * Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
 * Copyright 2016-2017 NXP
 *
 * SPDX-License-Identifier: BSD-3-Clause
* 
*
****************************************************************************//*!
*
* @brief  Subtraction
* 
*******************************************************************************/
#ifndef _MLIB_SUB_F32_H_
#define _MLIB_SUB_F32_H_

#if defined(__cplusplus)
extern "C" {
#endif

/*******************************************************************************
* Includes
*******************************************************************************/
#include "mlib_types.h"

/*******************************************************************************
* Macros
*******************************************************************************/  
#define MLIB_Sub_F32_Ci(f32Min, f32Sub)    MLIB_Sub_F32_FCi(f32Min, f32Sub)
  
/***************************************************************************//*!
*
* f32Out = f32Min - f32Sub
* Without saturation
*******************************************************************************/ 
static inline frac32_t MLIB_Sub_F32_FCi(register frac32_t f32Min, register frac32_t f32Sub)
{
    return(f32Min - f32Sub);
}
 
#if defined(__cplusplus)
}
#endif

#endif /* _MLIB_SUB_F32_H_ */
